#!/usr/bin/perl

########################################
# Script by Matt of Bumderland
# http://www.bumderland.com
# bookbaghead@hotmail.com
########################################

########################################
#  Check IP (Universal->ban from one, ban from all)
########################################
open (BANNED, "ipban.dat");
$banned = <BANNED>;
close (BANNED);
@banned = split(/,/,$banned);
foreach $banned (@banned)
{
	$test_position = index($ENV{'REMOTE_ADDR'},$banned);
	if ($test_position eq "0")
	{
		open(SET,"uniset.dat");
		$set = <SET>;
		close(SET);
		@unisettings = split(/,/,$set);
		print "Content-type: text/html\n\n";  #  Tells the browser that this is an HTML document
		print $unisettings[3];
		exit;
	}
}

########################################
# Read Universal Settings
########################################
open(SET,"uniset.dat");
$set = <SET>;
close(SET);
@unisettings = split(/,/,$set);
$nogame = $unisettings[0];
$defaultgame = $unisettings[1];
$nodatamessage = $unisettings[4];
$nogamemessage = $unisettings[5];
$gamenoexistmessage = $unisettings[6];
$badreferrermessage = $unisettings[7];

########################################
# If there is a Query String, Get Entries from Query String
########################################
if(length($ENV{'QUERY_STRING'}) > 1)
{
	@qpairs = split(/&/,$ENV{'QUERY_STRING'});  #  splits up each pair (name=value)
	foreach $qpair(@qpairs)  #  starts loop to store each individual value
	{
		($name,$value) = split(/=/,$qpair);  #  splits the name=value string into a string for each field
		$value =~ s/\+/ /g;  # converts plusses to spaces
		$value =~ s/%(..)/pack("c",hex($1))/ge;  #  converts special symbols (%20 to whatever)
		if(exists($entry{lc($name)}))
		{
			$entry{lc($name)} = $entry{lc($name)}."/$value";  #  defines form field
		}
		else
		{
			$entry{lc($name)} = $value;
		}
	}
}

########################################
# If no Query String, Get Entries from forms
########################################
else
{
	if($ENV{'CONTENT_LENGTH'} > 1)
	{
		read (STDIN, $unformatted, $ENV{'CONTENT_LENGTH'});  #  stores the unformated form data
		@pairs = split(/&/,$unformatted);  #  splits up each pair (name=value)
		foreach $pair(@pairs)  #  starts loop to store each individual value
		{
			($name,$value) = split(/=/,$pair);  #  splits the name=value string into a string for each field
			$value =~ s/\+/ /g;  # converts plusses to spaces
			$value =~ s/%(..)/pack("c",hex($1))/ge;  #  converts special symbols (%20 to whatever)
			if(exists($entry{lc($name)}))
			{
			$entry{lc($name)} = $entry{lc($name)}."/$value";  #  defines form field
			}
			else
			{
				$entry{lc($name)} = $value;
			}
		}
	}
	else
	{
		print "Content-type: text/html\n\n";  #  Tells the browser that this is an HTML document
		print $nodatamessage;
		exit;
	}
	$count = 0;
}

########################################
# Check for game field
########################################
if(!(exists $entry{'game'}))
{
	if($nogame == 1){$entry{'game'} = $defaultgame."/";}
	if($nogame == 2)
	{
		print "Content-type: text/html\n\n";  #  Tells the browser that this is an HTML document
		print $nogamemessage;
		exit;
	}
}
else
{
	if($entry{'game'} ne "")
	{
		$entry{'game'} = $entry{'game'}."/";
	}
}

########################################
# Check to make sure that game exists
########################################
if(!(-e "$entry{'game'}scores.dat"))
{
	print "Content-type: text/html\n\n";  #  Tells the browser that this is an HTML document
	print $gamenoexistmessage;
	exit;
}
#else
#{
#	print "Content-type: text/html\n\n";  #  Tells the browser that this is an HTML document
#	print "$entry{'game'}scores.dat";
#	exit;
#}

########################################
# Check Referer
########################################
open(Referer,"$entry{'game'}refer.dat");
$refer=<Referer>;
close(Referer);
if (length($refer) >= 1)
{
	@refer = split(/,/,$refer);
	Check: foreach $refer(@refer)
	{
		if(lc($ENV{'HTTP_REFERER'}) =~ lc($refer))
		{
			$refcheck = "1";
			last Check;		
		}
	}
	if($refcheck ne "1")
	{
		print "Content-type: text/html\n\n";  #  Tells the browser that this is an HTML document
		print $badreferrermessage;
		exit;
	}
}

########################################
# Read Settings
########################################
open(SET,"$entry{'game'}set.dat");
$set = <SET>;
close(SET);
@settings = split(/,/,$set);
$max = $settings[1];
$time = $settings[2];
$zone = $settings[3];
$duplicatecheck = $settings[4];
$htmlfilter = $settings[5];
$amax = $settings[6];
$removal = $settings[7];  #Day of month on which to clear normal scores
$nextclear = $settings[8];  #Next month on which to clear normal scores
$forward = $settings[9];  #Page to forward to
$ini = $settings[10];  #How many scores to include in the generated INI file
$aini = $settings[11];  #For all-time scores
$cheatmessage = $settings[12];

########################################
# Get Field Data
########################################
open(FIELDS,"$entry{'game'}fields.dat");
$properties = <FIELDS>;
close(FIELDS);
($fields,$properties) = split(/\|/,$properties);
@fields = split(/,/,$fields);
@properties = split(/,/,$properties);
$count = 0;
foreach $field (@fields)
{
	$properties{$field} = $properties[$count];
	$number{$field} = $count;  #  I need to know the numbers of cerain fields.
	$count++;
}
@properties = ();

########################################
# Add IP and Date
########################################
$entry{'ip'} = $ENV{'REMOTE_ADDR'};
$raw_seconds = time();
@date = localtime($raw_seconds);
$hour = $date[2]+1 + $time;
if( $hour < 1){$hour = 24 + $hour;}
if( $hour > 24){$hour = $hour - 24;}
if( $hour > 12)
{
	$AM_PM = "PM";
	$hour = $hour - 12;
}
else{$AM_PM = "AM";}
$year = $date[5]+1900;
$date[4]++;
if(length($date[1]) == 1){$date[1] = "0".$date[1];} 
if(length($date[0]) == 1){$date[0] = "0".$date[0];}
$entry{'date'} = "$date[4]/$date[3]/$year $hour:$date[1]:$date[0] $AM_PM $zone";

########################################
# Security Check
########################################
$scored = $entry{'score'};
$secure = $entry{'secure'};
open(SECURE,"$entry{'game'}check.dat");
while(<SECURE>)
{
	$row = $_;
	$chopped = chop($row);
	if($chopped ne "\n")
		{$row = $row.$chopped;}
	$check = $check."$row\n";
}
close(SECURE);
$status = eval($check);
if(lc($status) eq "f")
{
	print "Content-type: text/html\n\n";  #  Tells the browser that this is an HTML document
	print $cheatmessage;
	open(CHEAT,">>$entry{'game'}cheaters.dat");
	print CHEAT &prepare_entry."Failed Security Check\|\n";
	close(CHEAT);
	exit;
}

########################################
# Get scores from Database (unless they are to be cleared)
########################################
if(($removal != 0) && ($raw_seconds > $nextclear))
{
	$settings[8] = $raw_seconds + $removal;
	open(SET,">".$entry{'game'}."set.dat");
	print SET join(",",@settings);
	close(SET);
}
else
{
	open(SCORES, "$entry{'game'}scores.dat");
	while(<SCORES>)
	{
		$row = $_;
		$chopped = chop($row);
		if($chopped ne "\n")
			{$row = $row.$chopped;}
		push(@scores,$row);
	}
	close(SCORES);
}

########################################
# Get all-time scores from Database
########################################
open(SCORES, "$entry{'game'}ascores.dat");
while(<SCORES>)
{
	$row = $_;
	$chopped = chop($row);
	if($chopped ne "\n")
		{$row = $row.$chopped;}
	push(@ascores,$row);
}
close(SCORES);

########################################
# Check for Duplicate Scores (if option is enabled)
########################################
if($duplicatecheck == 1)
{
	$scored = $entry{'score'};
	foreach $score (@scores)
	{
		@pieces = split(/\|/,$score);
		if($scored eq $pieces[$number{'Score'}])
		{
			print "Content-type: text/html\n\n";  #  Tells the browser that this is an HTML document
			print "Sorry, duplicate scores are not allowed.";
			open(CHEAT,">>$entry{'game'}cheaters.dat");
			print CHEAT &prepare_entry."Duplicate Score\|\n";
			close(CHEAT);
			#$entry = join("\|",@entries);#  Why is this here?  Can I delete it?
			exit;
		}
	}
}

########################################
# Check for Duplicate Security Codes (if option is enabled)
########################################
if($duplicatecheck == 2)
{
	$secure = $entry{'secure'};
	foreach $score (@scores)
	{
		@pieces = split(/\|/,$score);
		if($secure eq $pieces[$number{'Secure'}]) 
		{
			print "Content-type: text/html\n\n";  #  Tells the browser that this is an HTML document
			print "The odds that you're not trying to cheat are pretty low.";
			open(CHEAT,">>$entry{'game'}cheaters.dat");
			print CHEAT &prepare_entry."Duplicate Security Code\|\n";
			close(CHEAT);
			exit;
		}
	}
}

########################################
# Perform Add-Ons
########################################
open(ADDON,"$entry{'game'}addons.dat");
while(<ADDON>)
{
	$row = $_;
	$chopped = chop($row);
	if($chopped ne "\n")
		{$row = $row.$chopped;}
	$addons = $addons."$row\n";
}
close(ADDON);
eval($addons);

########################################
# Sort and such with scores
########################################
push(@scores,&prepare_entry);
if($properties{$fields[0]} == 1)
{
	@scores = sort sort_numbers @scores;
}
else
{
	@scores = sort sort_strings @scores;
}
for(; scalar(@scores) > $max; )
{
	pop(@scores);
}

########################################
# Sort and such with all-time scores
########################################
push(@ascores,&prepare_entry);
if($properties{$fields[0]} == 1)
{
	@ascores = sort sort_numbers @ascores;
}
else
{
	@ascores = sort sort_strings @ascores;
}
for(; scalar(@ascores) > $amax; )
{
	pop(@ascores);
}

########################################
# Write Score to Database
########################################
$count=0;
open(SCORES, ">".$entry{'game'}."scores.dat");
if($ini > 0)
{
	open(INI,">".$entry{'game'}."scores.ini");
}
foreach $score (@scores)
{
	
	if(($ini > 0) && ($count<=$ini))
	{
		print INI "[$count]\n";
		@pieces = split(/\|/,$score);
		foreach $field (@fields)
		{
			if($field ne "secure")  #Sorry, no passing of security codes
			{
				print INI $field."=".$pieces[$number{$field}]."\n";
			}
		}
	}
	if($count != 0)
	{
		print SCORES "\n";
	}
	$count++;
	print SCORES "$score";
}
if($ini > 0)
{
	close(INI);
}
close(SCORES);

########################################
# Write All-Time Score to Database
########################################
$count=0;
open(SCORES, ">".$entry{'game'}."ascores.dat");
if($aini > 0)
{
	open(INI,">".$entry{'game'}."scores.ini");
}
foreach $ascore (@ascores)
{
	if(($aini > 0) && ($count<=$aini))
	{
		print INI "[a$count]\n";
		@pieces = split(/\|/,$score);
		foreach $field (@fields)
		{
			if($field ne "secure")  #Sorry, no passing of security codes
			{
				print INI $field."=".$pieces[$number{$field}]."\n";
			}
		}
	}
	if($count != 0)
	{
		print SCORES "\n";
	}
	$count++;
	print SCORES "$ascore";
}
if($aini > 0)
{
	close(INI);
}
close(SCORES);

########################################
# Display Thank You Page
########################################
if($forward eq "")
{
	$forward="thanks.html";
}
print "Content-type: HTTP/1.0 302 Jump\n";
print "Location: $forward\n\n";

########################################
# Prepare Entry to be added
########################################
sub prepare_entry
{
	$ready = "";
	foreach $field (@fields)
	{
		#print "$field--$entry{$field}--$properties{$field}<br>";
		if($htmlfilter == 1)
		{
			$entry{$field} =~ s/</&lt/g;
			$entry{$field} =~ s/>/&gt/g;
		}
		$entry{$field} =~ s/\|/\&\#124/g;  #  Filter out pipes
		$entry{$field} =~ s/\n/\<br\>/g;  #  Filter out line breaks
		$ready = $ready.$entry{$field}."\|";
	}
	return $ready;
}

########################################
# Sort Subroutines
########################################
sub sort_strings
{
	my(@AArray) = split(/\|/,$a);
	my(@BArray) = split(/\|/,$b);
	return (uc($AArray[0]) cmp uc($BArray[0]));
}

sub sort_numbers
{
	my(@AArray) = split(/\|/,$a);
	my(@BArray) = split(/\|/,$b);
	return ($BArray[0] <=> $AArray[0]);
}
