#!/usr/bin/perl

########################################
# Script by Matt of Bumderland
# http://www.bumderland.com
# bookbaghead@hotmail.com
########################################

########################################
# Display Header
########################################
print "Content-type: text/html\n\n";  #  Tells the browser that this is an HTML document

########################################
# Get Variables from Form
########################################
if($ENV{'CONTENT_LENGTH'} > 3)
{
	read (STDIN, $unformatted, $ENV{'CONTENT_LENGTH'});  #  stores the unformated form data
	@pairs = split(/&/,$unformatted);  #  splits up each pair (name=value)
	foreach $pair(@pairs)  #  starts loop to store each individual value
	{
		($name,$value) = split(/=/,$pair);  #  splits the name=value string into a string for each field
		$value =~ s/\+/ /g;  # converts plusses to spaces
		$value =~ s/%(..)/pack("c",hex($1))/ge;  #  converts special symbols (%20 to whatever)
		$form{lc($name)} = "$value";  #  defines form field
	}
}

########################################
# Get Field Data
########################################
open(FIELDS,"$form{'game'}fields.dat");
$properties = <FIELDS>;
close(FIELDS);
($fields,$properties) = split(/\|/,$properties);
@fields = split(/,/,$fields);
@properties = split(/,/,$properties);
$count = 0;
foreach $field (@fields)
{
	$properties{$field} = $properties[$count];
	$number{$field} = $count;  #  I need to know the numbers of certain fields.
	$count++;
}
@properties = ();

########################################
# Read Settings
########################################
open(SET,"$form{'game'}set.dat");
$set = <SET>;
close(SET);
@settings = split(/,/,$set);
$query = @settings[0];

########################################
# Get "scores-to-display" data
########################################
if ($form{'scores'} =~ "-" && length($form{'scores'}) > 2)
{
	($first,$last) = split(/-/,$form{'scores'});
	$first = $first - 1;  #  This allows me to make the first score one instead on zero
	$last = $last - 1;  #  Must be done because of previous line
}
else
{
	$form{'scores'}=$query;
	if ($form{'scores'} =~ "-" && length($form{'scores'}) > 2)
	{
		($first,$last) = split(/-/,$form{'scores'});
		$first = $first - 1;  #  This allows me to make the first score one instead on zero
		$last = $last - 1;  #  Must be done because of previous line
	}
	else
	{
		$form{'scores'} = "1-10";
		$first = 0;
		$last = 9;
	}
}

########################################
# Check Password and Load Page Accordingly
########################################
$pass = crypt($form{'password'}, "MM");
open(USERS, "jxzdfx.dat");
$users = <USERS>;
close(USERS);
%users = split(/\,/,$users);
if($users{$form{'name'}} ne $pass)
{
	print "<html><head><title>Log-in Failed</title></head><body>Your username and/or password are invalid.</body></html>";
}
else
{
########################################
# Read Databases
########################################
if(substr($form{'type'},0,1) eq "a")  #  Open all-time high scores
{
#  Main
open(MAIN, "$form{'game'}amain.dat");
while(<MAIN>)
{
	$row = $_;
	$chopped = chop($row);
	if($chopped ne "\n")
		{$row = $row.$chopped;}
	$main = $main."$row\n";
}
close(MAIN);
#  Entries
open(ENT, "$form{'game'}aent.dat");
while(<ENT>)
{
	$row = $_;
	$chopped = chop($row);
	if($chopped ne "\n")
		{$row = $row.$chopped;}
	$ent = $ent."$row\n";
}
close(ENT);
#  Scores
open(SCORES, "$form{'game'}ascores.dat");
while(<SCORES>)
{
	$row = $_;
	$chopped = chop($row);
	if($chopped ne "\n")
		{$row = $row.$chopped;}
	push(@scores,$row);
}
close(SCORES);
}
else
{
#  Main
open(MAIN, "$form{'game'}main.dat");
while(<MAIN>)
{
	$row = $_;
	$chopped = chop($row);
	if($chopped ne "\n")
		{$row = $row.$chopped;}
	$main = $main."$row\n";
}
close(MAIN);
#  Entries
open(ENT, "$form{'game'}ent.dat");
while(<ENT>)
{
	$row = $_;
	$chopped = chop($row);
	if($chopped ne "\n")
		{$row = $row.$chopped;}
	$ent = $ent."$row\n";
}
close(ENT);
#  Scores
open(SCORES, "$form{'game'}scores.dat");
while(<SCORES>)
{
	$row = $_;
	$chopped = chop($row);
	if($chopped ne "\n")
		{$row = $row.$chopped;}
	push(@scores,$row);
}
close(SCORES);
}

########################################
# Sort Scores
########################################
if(!(exists $form{'sort'})){$form{'sort'} = $fields[0];}
if (($number{$form{'sort'}} ne "0") || (substr($query{'order'},0,1) eq "a"))
{	
	if($properties{$form{'sort'}} == 0)
	{
		if(substr($form{'order'},0,1) eq "a")
		{
			@scores = reverse sort sort_strings @scores;
		}
		else
		{
			@scores = sort sort_strings @scores;
		}
	}
	else
	{
		if(substr($form{'order'},0,1) eq "a")
		{
			@scores = reverse sort sort_numbers @scores;
		}
		else
		{
			@scores = sort sort_numbers @scores;
		}
	}
}

########################################
# Make Code to Display Scores
########################################
$numberofscores = scalar(@scores);
for($count = $first; ($count <= $last) && ($count < $numberofscores); $count++)
{
	$rank = $count + 1;
	$temp=$ent;
	$temp =~ s/\<form/\&lt;form/gi;
	$temp =~ s/\<\/form\>/\&lt;\/form\&gt;/gi;
	$temp =~ s/\<input/\&lt;input/gi;
	$temp =~ s/\<select/\&lt;select/gi;
	$temp =~ s/\<option/\&lt;option/gi;
	$temp =~ s/\<textarea/\&lt;textarea/gi;
	$temp =~ s/\<\/textarea/\&lt;\/textarea/gi;
	$temp =~ s/\<script/\&lt;script/gi;
	$temp =~ s/\<!--Rank--\>/$rank/gi;
	$temp =~ s/\<!--Checkbox--\>/\<input type=checkbox name=$count value=1\>/gi;
	@pieces = split(/\|/,$scores[$count]);
	foreach $field (@fields)
	{
		$temp =~ s/\<!--$field--\>/$pieces[$number{$field}]/gi;
		#print "$field--$pieces[$number{$field}]<br>";
	}
	$displayent = $displayent.$temp;
}

########################################
# Format and Display Page
########################################
$displayent = "<form action=\"deletescores.cgi\" method=post>".$displayent;
$main =~ s/\<form/\&lt;form/gi;
$main =~ s/\<\/form\>/\&lt;\/form\&gt;/gi;
$main =~ s/\<input/\&lt;input/gi;
$main =~ s/\<select/\&lt;select/gi;
$main =~ s/\<option/\&lt;option/gi;
$main =~ s/\<textarea/\&lt;textarea/gi;
$main =~ s/\<\/textarea/\&lt;\/textarea/gi;
$main =~ s/\<script/\&lt;script/gi;
$main =~ s/\<!--Entries--\>/$displayent/gi;
$main =~ s/\<body\>/<form action=editscores.cgi method=post>Sort by: 
<input type=text name=sort value="$form{'sort'}">
<select name=order>
<option value=d selected>Descending
<option value=a>Ascending 
<\/select><br>
<input type=text name=scores>
<input type=hidden name=game value="$form{'game'}">
<input type=hidden name=type value="$form{'type'}">
<input type=hidden name=password value="$form{'password'}">
<input type=hidden name=name value="$form{'name'}">
<input type=submit value="View These Scores">
<\/form>/gi;
$main =~ s/\<\/body\>/<hr><input type=hidden name=password value="$form{'password'}"><input type=hidden name=name value="$form{'name'}"><input type=hidden name=game value="$form{'game'}"><input type=hidden name=type value="$form{'type'}"><input type=hidden name=sort value="$form{'sort'}"><input type=hidden name=order value="$form{'order'}"><input type=submit name=submit value=Edit><input type=submit name=submit value=Delete><\/form><\/body>/gi;
print "$main";
}

########################################
# Sort Subroutines
########################################
sub sort_strings
{
	my(@AArray) = split(/\|/,$a);
	my(@BArray) = split(/\|/,$b);
	return (uc($AArray[$number{$form{'sort'}}]) cmp uc($BArray[$number{$form{'sort'}}]));
}

sub sort_numbers
{
	my(@AArray) = split(/\|/,$a);
	my(@BArray) = split(/\|/,$b);
	return ($BArray[$number{$form{'sort'}}] <=> $AArray[$number{$form{'sort'}}]);
}

sub oorder
{
	if(lc($1) eq $form{'sort'})
	{
		if(substr($form{'order'},0,1) eq "a")
		{
			return "d";
		}
		else
		{
			return "a";
		}
	}
	else
	{
		return $form{'order'};
	}
}